# ชื่อโครงงาน : ที่ใส่รหัสผ่านเพื่อปลดล็อกประตูนิรภัย
โครงงานนี้เป็นส่วนหนึ่งของรายวิชา 01204223 Practicum for Computer Engineering ภาคปลาย ปีการศึกษา 2564 หมู่ 11,12

## สมาชิกผู้จัดทำ:  
> :shipit:นิสิตภาควิชาวิศวกรรมคอมพิวเตอร์ คณะวิศวกรรมศาสตร์ มหาวิทยาลัยเกษตรศาสตร์ วิทยาเขตบางเขน:shipit:  

6310500325 ปองภพ ไกรรวีโรจ<br>
6310500066 สุคชาธัม เซียวศิริถาวร<br>
6310500350 วิชญ์นพัฒน์ จำปาเรือง<br>
6310500287 ตะวันฉาย ฉัตรกุล ณ อยุธยา<br>

## Table of contents    
  - [รายละเอียดไฟล์ Source Code](#รายละเอียดไฟล์-source-code)
  - [รายการไลบรารีและเฟรมเวิร์คที่ใช้](#รายการไลบรารีและเฟรมเวิร์คที่ใช้)

  - [รายการอุปกรณ์ฮาร์ดแวร์ที่ใช้](#รายการอุปกรณ์ฮาร์ดแวร์ที่ใช้)


## รายละเอียดไฟล์
### Hardware   
```
Hardware
│
│   blink.ino : โปรแกรมสำหรับการควบคุม Hardware ทุกอย่าง
│
```
### Frontend  
```
Frontend and Backend
│   1_upload_picture.py : โปรแกรมสำหรับการอัพโหลดรูปภาพผู้ใช้งาน   
│   0_frontend.py : โปรแกรม GUI สำหรับการแสดงผล การสแกนหน้าเพื่อเข้าใช้งาน สถานะเปิดปิดของประตู
│
```
### Backend  
    
```
Frontend and Backend
│   Can_Pass : โฟลเดอร์ที่จัดเก็บใบหน้าของคนทั้งหมดที่สามารถสแกนหน้าเพื่อผ่านเข้าประตูได้
│   Can_not_Pass : โฟลเดอร์ที่จัดเก็บใบหน้าของคนทั้งหมดที่ไม่สามารถสแกนหน้าเพื่อผ่านเข้าประตู
│
└───log
│   │   1_status.log : ก็บประวัติการใช้งาน (เก็บทั้งหมดไม่ว่าจะผ่านหรือไม่ผ่าน)  
│   │   1_status.txt : status ปัจจุบันของประตุเปิดหรือปิด
│   
│   0_backend.py : โปรแกรมสำหรับการ detect ใบหน้า, ควบคุมการแสดงผล, ควบคุมการเปิดปิดประตู
│   practicum.py : ใช้ในการส่งค่าระหว่าง backend กับ hardware

```
หมายเหตุ : ในการใช้งานจำเป็นที่จะต้องให้โปรแกรม Frontend และ Backend ทั้งหมด อยู่ภายใต้ folder เดียวกัน

### Others  
```
Picture of Project : โฟลเดอร์ที่จัดเก็บรูปภาพของตัวโปรเจคที่ได้ทำการสร้างขึ้นมา
Picture for test : โฟลเดอร์ที่จัดเก็บใบหน้าของผู้คนทั้งหมดสำหรับการทดสอบ
Schematic : โฟลเดอร์ที่จัดเก็บ Schematic ของวงจร
README.md : ไฟล์ระบุชื่อกลุ่ม ชื่อโครงงาน รายชื่อผู้จัดทำ รายละเอียดไฟล์ รายการไลบรารี/เฟรมเวิร์คที่ใช้ และรายการอุปกรณ์ฮาร์ดแวร์ที่ใช้
License.md : ไฟล์ระบุเงื่อนไขการอนุญาตให้ผู้อื่นนำงานนี้ไปใช้
```


## รายการไลบรารีและเฟรมเวิร์คที่ใช้
### Hardware 
`usbdrv.h` `Wire.h` `Servo.h` `LiquidCrystal_I2C.h`  

### Frontend 
`logging` `tkinter` `datetime` `turtle` `cv2` `PIL`  

### Backend 
`face_recognition` `cv2` `numpy` `time` `os` `datetime` 

## รายการอุปกรณ์ฮาร์ดแวร์ที่ใช้
<ul>
  <li>Board NodeMCU - ATmega328p (Practicum Board v3.2 CPE. KU 2020-11) 2 ตัว</li>
  <li>Peripheral board (PRACTICUM PROTOBOARD CPE. KU) 3 ชิ้น</li>
  <li>สายแพ 3 เส้น</li>
  <li>Switch button กดติดปล่อยดับแบบ 4 ขา ขนาด 6x6x5 mm 6 ชิ้น</li>
  <li>Servo SG90S 1 ตัว</li>
  <li>1602 LCD (Blue Screen) 16x2 LCD with backlight of the LCD screen พร้อม I2CInterface 5V 1 ชุด</li>
  <li>Jumper wire Female-Female 4 เส้น</li>
  <li>Jumper wire Male-Female 3 เส้น</li>
  <li>Pin header ที่เพิ่มเข้ามา มีหลากหลายขนาด ดังนี้</li>
    <ul>
      <li>ขนาด 5x2 : 3 ชิ้น</li>
      <li>ขนาด 2x1 : 1 ชิ้น</li>
      <li>ขนาด 1x1 : 5 ชิ้น</li>
    </ul>
  </ul>
